<?xml version="1.0" encoding="UTF-8"?>

<!--
	* Licensed Materials - Property of IBM
	* 5724-C11, 5724-C13, 5724-D17
	* (C) Copyright IBM Corporation 1997, 2003. All Rights Reserved.
	* US Government Users Restricted Rights- Use, duplication or disclosure
	* restricted by GSA ADP Schedule Contract with IBM Corp.
-->

<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:java="http://xml.apache.org/xslt/java"	
	exclude-result-prefixes="xalan java" >

	<xsl:output method="xml" standalone="no" indent="yes"/>	
	<xsl:param name="AutoUpgradeOperations" select="'yes'"/>	

	<!-- 
	***************************************************************************************************************************************************************************
	Global variable definitions
	***************************************************************************************************************************************************************************
	-->

	<!-- *** Format utility variables *** -->

	<xsl:variable name="newline">
	<xsl:text>
	</xsl:text>
	</xsl:variable>	

	<xsl:variable name="objXSLTUtils" select="java:com.ibm.btools.itools.cwconverter.xslt.ext.XSLTUtils.new()"/>	

	<!-- 
	***************************************************************************************************************************************************************************
	Converts the map from version 4.1.1 to the latest.
	***************************************************************************************************************************************************************************
	-->


	<!-- *** XSLT starts at the root template *** -->		
	<xsl:template match="/" >
		
		<!-- *** write the DTD for our root element NativeMap *** -->
		<xsl:text disable-output-escaping="yes">
			&lt;!DOCTYPE NativeMap [
			&lt;!--
			 Base Elements and Attributes
			-->
			&lt;!ELEMENT Title (#PCDATA)>
			&lt;!ELEMENT Desc (#PCDATA)>
			&lt;!ELEMENT Value (#PCDATA)>
			&lt;!ELEMENT Default (#PCDATA)>
			&lt;!ELEMENT CreateTime (#PCDATA)>
			&lt;!ATTLIST CreateTime Format CDATA #REQUIRED>
			&lt;!ELEMENT ModifyTime (#PCDATA)>
			&lt;!ATTLIST ModifyTime Format CDATA #REQUIRED>
			&lt;!ELEMENT GUICoord EMPTY>
			&lt;!ATTLIST GUICoord X CDATA #REQUIRED>
			&lt;!ATTLIST GUICoord Y CDATA #REQUIRED>
			&lt;!ELEMENT GUICoord2 (GUICoord,GUICoord)>
			&lt;!ELEMENT GUICoords (GUICoord,GUICoord+)>
			&lt;!ELEMENT Color EMPTY>
			&lt;!ATTLIST Color R CDATA #REQUIRED>
			&lt;!ATTLIST Color G CDATA #REQUIRED>
			&lt;!ATTLIST Color B CDATA #REQUIRED>
			&lt;!ELEMENT GUIFont (FaceName,PointSize,Height,Color)>
			&lt;!ATTLIST GUIFont Italic CDATA #REQUIRED>
			&lt;!ATTLIST GUIFont UnderLine CDATA #REQUIRED>
			&lt;!ATTLIST GUIFont StrikeOut CDATA #REQUIRED>
			&lt;!ELEMENT FaceName (#PCDATA)>
			&lt;!ELEMENT PointSize (#PCDATA)>
			&lt;!ELEMENT Height (#PCDATA)>

			&lt;!--
			 Header section
			-->
			&lt;!ELEMENT Header (Title,Desc,CreateTime,ModifyTime)>

			&lt;!--
			 Base Elements and Attributes
			-->
			&lt;!ELEMENT Index (#PCDATA)>
			&lt;!ELEMENT VarName (#PCDATA)>
			&lt;!ELEMENT ID (#PCDATA)>
			&lt;!ELEMENT Name (#PCDATA)>
			&lt;!ELEMENT Comment (#PCDATA)>
			&lt;!ELEMENT Delimiter (#PCDATA)>
			&lt;!ELEMENT DelimBefore (#PCDATA)>
			&lt;!ELEMENT DelimTrailing (#PCDATA)>
			&lt;!ELEMENT SplitIndex (#PCDATA)>
			&lt;!ELEMENT SubMapName (#PCDATA)>
			&lt;!ELEMENT SubMapType (#PCDATA)>
			&lt;!ELEMENT SubMapCond (#PCDATA)>
			&lt;!ELEMENT ValueIsString (#PCDATA)>
			&lt;!ELEMENT SetValueString (#PCDATA)>
			&lt;!ELEMENT RelationshipName (#PCDATA)>
			&lt;!ELEMENT ParticipantName (#PCDATA)>
			&lt;!ELEMENT Direction (#PCDATA)>

			&lt;!--
			 Map Document
			-->
			&lt;!ELEMENT NativeMap (Header,DLMInfo,GUIBody,Messages)>
			&lt;!ATTLIST NativeMap Name CDATA #REQUIRED>
			&lt;!ATTLIST NativeMap Version CDATA #REQUIRED>
			&lt;!ATTLIST NativeMap FormatVersion CDATA #REQUIRED>

			&lt;!--
			 DLM Info section
			-->
			&lt;!ELEMENT DLMInfo (Desc,CreationDate,LastModified,OwnerType,TraceLevel,IsFrozen,IsCompiled,DLMClassPath,ParentName,ParentVersion,Properties,DLMMethod)>
			&lt;!ATTLIST DLMInfo Name CDATA #REQUIRED>
			&lt;!ATTLIST DLMInfo Version CDATA #REQUIRED>
			&lt;!ELEMENT OwnerType (#PCDATA)>
			&lt;!ELEMENT CreationDate (#PCDATA)>
			&lt;!ELEMENT LastModified (#PCDATA)>
			&lt;!ELEMENT TraceLevel (#PCDATA)>
			&lt;!ELEMENT DLMClassPath (#PCDATA)>
			&lt;!ELEMENT ParentName (#PCDATA)>
			&lt;!ELEMENT ParentVersion (#PCDATA)>
			&lt;!ELEMENT IsFrozen EMPTY>
			&lt;!ATTLIST IsFrozen Value (Yes|No) #REQUIRED>
			&lt;!ELEMENT IsCompiled EMPTY>
			&lt;!ATTLIST IsCompiled Value (Yes|No) #REQUIRED>

			&lt;!ELEMENT DLMMethod (DLMMethodName,Desc,DLMParmRefs,ModelDLMMethod)>
			&lt;!ATTLIST DLMMethod Name CDATA #REQUIRED>
			&lt;!ATTLIST DLMMethod Version CDATA #REQUIRED>
			&lt;!ELEMENT DLMMethodName (#PCDATA)>

			&lt;!ELEMENT ModelDLMMethod (Diagram)>

			&lt;!ELEMENT DLMParmRefs (DLMParmRef)*>
			&lt;!ELEMENT DLMParmRef (ParmUsage,SeqNo,IsBOArray,ParmObjType,ParmVersionReq,ParmStatus)>
			&lt;!ATTLIST DLMParmRef MethodName CDATA #REQUIRED>
			&lt;!ATTLIST DLMParmRef Version CDATA #REQUIRED>
			&lt;!ATTLIST DLMParmRef DLMParmName CDATA #REQUIRED>
			&lt;!ELEMENT ParmUsage (#PCDATA)>
			&lt;!ELEMENT SeqNo (#PCDATA)>
			&lt;!ELEMENT IsBOArray EMPTY>
			&lt;!ATTLIST IsBOArray Value (Yes|No) #REQUIRED>
			&lt;!ELEMENT ParmObjType (#PCDATA)>
			&lt;!ELEMENT ParmVersionReq (#PCDATA)>
			&lt;!ELEMENT ParmStatus (#PCDATA)>


			&lt;!--
			 GUI Body section
			-->
			&lt;!ELEMENT Path (#PCDATA)>
			&lt;!ELEMENT Separator (#PCDATA)>
			&lt;!ELEMENT SeparatorPre (#PCDATA)>
			&lt;!ELEMENT SeparatorPost (#PCDATA)>
			&lt;!ELEMENT GUIBody (GUIBusObjs,GUIOperations)>
			&lt;!ELEMENT GUIBusObjs (GUIBusObj)*>
			&lt;!ELEMENT GUIBusObj (RoleType,GUICoord2)>
			&lt;!ATTLIST GUIBusObj VarName CDATA #REQUIRED>
			&lt;!ATTLIST GUIBusObj Index CDATA #REQUIRED>
			&lt;!ATTLIST GUIBusObj BOType CDATA #REQUIRED>
			&lt;!ATTLIST GUIBusObj Version CDATA #REQUIRED>
			&lt;!ELEMENT RoleType (RoleIn|RoleOut|RoleTmp)>
			&lt;!ELEMENT RoleIn EMPTY>
			&lt;!ELEMENT RoleOut EMPTY>
			&lt;!ELEMENT RoleTmp (TmpVarAttrs)>
			&lt;!ELEMENT TmpVarAttrs (TmpVarAttr)*>
			&lt;!ELEMENT TmpVarAttr EMPTY>
			&lt;!ATTLIST TmpVarAttr Name CDATA #REQUIRED>
			&lt;!ATTLIST TmpVarAttr Index CDATA #REQUIRED>
			&lt;!ATTLIST TmpVarAttr AttrType CDATA #REQUIRED>
			&lt;!ELEMENT GUIOperations (OpCopy|OpJoin|OpSplit|OpSubMap|OpSetValue|OpIdentity|OpCustom)*>
			&lt;!ELEMENT OpCopy (BaseAttr)>
			&lt;!ELEMENT OpJoin (BaseAttr,Delimiters)>
			&lt;!ELEMENT OpSplit (BaseAttr,SplitIndex,Separator)>
			&lt;!ELEMENT OpSubMap (BaseAttr,SubMapName,SubMapType,SubMapCond)>
			&lt;!ELEMENT OpSetValue (BaseAttr,ValueIsString,SetValueString)>
			&lt;!ELEMENT OpIdentity (BaseAttr,RelationshipName,ParticipantName,Direction)>
			&lt;!ELEMENT OpCustom (BaseAttr)>
			&lt;!ELEMENT BaseAttr (BOPathDst,BOPathSrcs,Comment)>
			&lt;!ATTLIST BaseAttr UniqIDRef CDATA #REQUIRED>
			&lt;!ATTLIST BaseAttr ExecutionOrder CDATA #REQUIRED>
			&lt;!ATTLIST BaseAttr DisplayOrder CDATA #IMPLIED>
			&lt;!ATTLIST BaseAttr AutoUpgrade (Yes|No) #REQUIRED>
			&lt;!ATTLIST BaseAttr BusObjVersion CDATA #REQUIRED>
			&lt;!ELEMENT Delimiters (Delimiter)*>
			&lt;!ELEMENT BOPathSrcs (BOPath*)>
			&lt;!ELEMENT BOPathDst (BOPath)>
			&lt;!ELEMENT BOPath (Path)>
			&lt;!ATTLIST BOPath AttrType CDATA #REQUIRED>
			&lt;!ATTLIST BOPath AttrClass (TypeBasic|TypeBO|TypeTempVar|TypeVerb) #REQUIRED>
			&lt;!ATTLIST BOPath AttrCardinality (1|N) #REQUIRED>

			&lt;!--
			 ModelElement
			-->
			&lt;!ELEMENT ModelElement (Desc)>
			&lt;!ATTLIST ModelElement Version CDATA #REQUIRED>

			&lt;!--
			 ModelStructureElement
			-->
			&lt;!ELEMENT ModelStructureElement (ModelElement)>
			&lt;!ATTLIST ModelStructureElement Name CDATA #REQUIRED>

			&lt;!--
			 ModelActivityElement
			-->
			&lt;!ELEMENT ModelActivityElement (ModelElement,Label)>
			&lt;!ATTLIST ModelActivityElement UniqID ID #REQUIRED>
			&lt;!ELEMENT Label (#PCDATA)>

			&lt;!--
			 Misc - dummy elements
			-->
			&lt;!ELEMENT PseudoState (Node)>
			&lt;!ELEMENT ProcessStep (Node)>

			&lt;!--
			 Diagram
			-->
			&lt;!ELEMENT Diagram (ModelStructureElement,Declaration,DiagramBody)>
			&lt;!ATTLIST Diagram Name ID #REQUIRED>
			&lt;!ATTLIST Diagram Version CDATA #REQUIRED>
			&lt;!ELEMENT Declaration (Section1,Section2)>
			&lt;!ELEMENT Section1 (#PCDATA)>
			&lt;!ELEMENT Section2 (#PCDATA)>
			&lt;!ELEMENT DiagramBody (ModelActivityElement,Nodes,Links)>

			&lt;!--
			 Nodes - note that there can be only one start node
			-->
			&lt;!ELEMENT Node (ModelActivityElement)>
			&lt;!ATTLIST Node UserModified (Yes|No) "No">
			&lt;!ELEMENT Nodes ( (ActionNode|SubMapNode|SubDiagramNode|IteratorNode|ServiceNode|OutboundServiceNode|InboundServiceNode|SuccessEndNode|FailureEndNode|BreakNode|ForkNode|JoinNode)* |
			 (InitialNode, (ActionNode|SubMapNode|SubDiagramNode|IteratorNode|ServiceNode|OutboundServiceNode|InboundServiceNode|SuccessEndNode|FailureEndNode|BreakNode|ForkNode|JoinNode)*) |
			 ( (ActionNode|SubMapNode|SubDiagramNode|IteratorNode|ServiceNode|OutboundServiceNode|InboundServiceNode|SuccessEndNode|FailureEndNode|BreakNode|ForkNode|JoinNode)*,InitialNode) |
			 ( (ActionNode|SubMapNode|SubDiagramNode|IteratorNode|ServiceNode|OutboundServiceNode|InboundServiceNode|SuccessEndNode|FailureEndNode|BreakNode|ForkNode|JoinNode)*,InitialNode, (ActionNode|SubMapNode|SubDiagramNode|IteratorNode|ServiceNode|OutboundServiceNode|InboundServiceNode|SuccessEndNode|FailureEndNode|BreakNode|ForkNode|JoinNode)*))>
			&lt;!ELEMENT CompositeNode (ProcessStep)>
			&lt;!ATTLIST CompositeNode DiagramRef IDREF #REQUIRED>

			&lt;!ELEMENT InitialNode (PseudoState,CorrelationSet*)>
			&lt;!ELEMENT SuccessEndNode (PseudoState)>
			&lt;!ELEMENT FailureEndNode (PseudoState)>
			&lt;!ELEMENT BreakNode (PseudoState)>
			&lt;!ELEMENT ForkNode (PseudoState)>
			&lt;!ELEMENT JoinNode (PseudoState)>
			&lt;!ELEMENT ActionNode (ProcessStep,CodeFragment)>
			&lt;!ELEMENT SubMapNode (ActionNode)>
			&lt;!ATTLIST SubMapNode SubMapName CDATA #REQUIRED>
			&lt;!ATTLIST SubMapNode SubMapType CDATA #REQUIRED>
			&lt;!ELEMENT CodeFragment (#PCDATA)>
			&lt;!ATTLIST CodeFragment Type (Java|XML) #REQUIRED>
			&lt;!ELEMENT ServiceNode (ProcessStep,RegBusObjName,RegBusObjVerb,RegBusObjRefName,CmpBusObjName,CmpBusObjVerb,CmpBusObjRefName,WaitTimeOut,CorrelationSet*)>
			&lt;!ELEMENT RegBusObjName (#PCDATA)>
			&lt;!ELEMENT RegBusObjVerb (#PCDATA)>
			&lt;!ELEMENT RegBusObjRefName (#PCDATA)>
			&lt;!ELEMENT CmpBusObjName (#PCDATA)>
			&lt;!ELEMENT CmpBusObjVerb (#PCDATA)>
			&lt;!ELEMENT CmpBusObjRefName (#PCDATA)>
			&lt;!ELEMENT WaitTimeOut (#PCDATA)>
			&lt;!ATTLIST WaitTimeOut Type (NotUsed|Constant|Parameter|Variable) #REQUIRED>
			&lt;!ELEMENT CorrelationSet (CorrelationAttribute+)>
			&lt;!ATTLIST CorrelationSet IsInit (Yes|No) "No">
			&lt;!ELEMENT CorrelationAttribute (AttributeName,VariableName)>
			&lt;!ELEMENT AttributeName (#PCDATA)>
			&lt;!ELEMENT VariableName (#PCDATA)>
			&lt;!ELEMENT OutboundServiceNode (ServiceNode)>
			&lt;!ATTLIST OutboundServiceNode IsSync CDATA #REQUIRED>
			&lt;!ELEMENT InboundServiceNode (ServiceNode)>
			&lt;!ELEMENT SubDiagramNode (CompositeNode)>
			&lt;!ELEMENT IteratorNode (CompositeNode,IteratorVariable,ThruThisObject,Start,Condition,Increment)>
			&lt;!ATTLIST IteratorNode Type (Attribute|BusObj|Loop) #REQUIRED>
			&lt;!ELEMENT IteratorVariable (#PCDATA)>
			&lt;!ELEMENT ThruThisObject (#PCDATA)>
			&lt;!ELEMENT Start (#PCDATA)>
			&lt;!ELEMENT Condition (#PCDATA)>
			&lt;!ELEMENT Increment (#PCDATA)>
			&lt;!ELEMENT DecisionNode (DecisionBranch,DecisionBranch+)>
			&lt;!ELEMENT DecisionBranch (Condition,Comment,Label,LinkID)>
			&lt;!ATTLIST DecisionBranch Type (NotUsed|Normal|Default|Exception) #REQUIRED>
			&lt;!ELEMENT LinkID (#PCDATA)>

			&lt;!--
			 Links
			-->
			&lt;!ELEMENT Link (ModelActivityElement,Connect)>
			&lt;!ELEMENT Links (TransitionLink|MessageLink|ExceptionLink)*>
			&lt;!ELEMENT Connect EMPTY>
			&lt;!ATTLIST Connect From IDREF #REQUIRED>
			&lt;!ATTLIST Connect To IDREF #REQUIRED>

			&lt;!ELEMENT TransitionLink (Link,GuardCondition)>
			&lt;!ELEMENT GuardCondition (#PCDATA)>
			&lt;!ELEMENT ExceptionLink (Link,ExceptionName)>
			&lt;!ELEMENT ExceptionName (#PCDATA)>
			&lt;!ELEMENT MessageLink (Link)>

			&lt;!--
			 Misc properties stuff - not exactly belong to diagram, but we stick them here!
			-->
			&lt;!ELEMENT Properties (Property)*>
			&lt;!ELEMENT Property (Attributes)>
			&lt;!ATTLIST Property Name CDATA #REQUIRED>
			&lt;!ELEMENT Attributes (Attribute)*>
			&lt;!ELEMENT Attribute (Value,Desc)>
			&lt;!ATTLIST Attribute Name CDATA #REQUIRED>
			&lt;!ATTLIST Attribute Type CDATA #REQUIRED>

			&lt;!--
			 Messages Element
			-->
			&lt;!ELEMENT Messages (CommonMessages,SpecificMessages)>
			&lt;!ELEMENT CommonMessages (#PCDATA)>
			&lt;!ELEMENT SpecificMessages (Msg)*>
			&lt;!ELEMENT Msg (MsgBody, MsgExpl)>
			&lt;!ATTLIST Msg msg_key CDATA #REQUIRED>
			&lt;!ELEMENT MsgBody (#PCDATA)>
			&lt;!ELEMENT MsgExpl (#PCDATA)>
			&lt;!ATTLIST SpecificMessages locale CDATA #REQUIRED>

			]>
		</xsl:text>
				
		<!-- *** Now write the real XML content for the root element NativeMap *** -->
		<xsl:apply-templates select="NativeMap" />	

	</xsl:template>

	<!-- *** the root template applies the NativeMap element *** -->
	<xsl:template match="NativeMap" >
		<xsl:element name="{name()}">
		<xsl:for-each select="@*">	
			<xsl:attribute name="{name()}">
				<xsl:choose>
					<xsl:when test="name() = 'FormatVersion'">
						<xsl:value-of select="'4.2.0'" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="." />						
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
		</xsl:for-each>		
		<xsl:value-of select="$newline" />
			<xsl:copy-of select="Header" />
			<xsl:value-of select="$newline" />
			
			<xsl:apply-templates select="DLMInfo" />
			<xsl:value-of select="$newline" />

			<xsl:apply-templates select="GUIBody" />
			<xsl:value-of select="$newline" />

			<xsl:apply-templates select="Messages" />
			<xsl:value-of select="$newline" />
		</xsl:element>
	</xsl:template>

	<!-- *** the NativeMap applies the DLMInfo element *** -->
	<xsl:template match="DLMInfo" >
		<xsl:element name="{name()}">
		<xsl:call-template name="writeAllAttirbutes" />
		<xsl:value-of select="$newline" />
			<xsl:copy-of select="Desc" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="CreationDate" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="LastModified" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="OwnerType" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="TraceLevel" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="IsFrozen" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="IsCompiled" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="DLMClassPath" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="ParentName" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="ParentVersion" />
			<xsl:value-of select="$newline" />
	
			<xsl:apply-templates select="Properties" />
			<xsl:value-of select="$newline" />

			<xsl:apply-templates select="DLMMethod" />
			<xsl:value-of select="$newline" />
		</xsl:element>
	</xsl:template>

	<!-- *** the DLMInfo applies the DLMMethod element *** -->
	<xsl:template match="DLMMethod" >
		<xsl:element name="{name()}">
		<xsl:call-template name="writeAllAttirbutes" />
		<xsl:value-of select="$newline" />
			<xsl:copy-of select="DLMMethodName" />
			<xsl:value-of select="$newline" />
			<xsl:copy-of select="Desc" />
			<xsl:value-of select="$newline" />
			<xsl:copy-of select="DLMParmRefs" />
			<xsl:value-of select="$newline" />
			<xsl:apply-templates select="ModelDLMMethod" />
			<xsl:value-of select="$newline" />
		</xsl:element>	
	</xsl:template>

	<!-- *** the DLMMethod applies the ModelDLMMethod element *** -->
	<xsl:template match="ModelDLMMethod" >
		<xsl:element name="{name()}">
		<xsl:value-of select="$newline" />
			<xsl:apply-templates select="Diagram" />
			<xsl:value-of select="$newline" />
		</xsl:element>	
	</xsl:template>

	<!-- *** the  ModelDLMMethod applies the Diagram element *** -->
	<xsl:template match="Diagram" >
		<xsl:element name="{name()}">
		<xsl:call-template name="writeAllAttirbutes" />
		<xsl:value-of select="$newline" />
			<xsl:copy-of select="ModelStructureElement" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="Declaration" />
			<xsl:value-of select="$newline" />

			<xsl:apply-templates select="DiagramBody" />
			<xsl:value-of select="$newline" />
		</xsl:element>
	</xsl:template>

	<!-- *** the Diagram applies the DiagramBody element *** -->
	<xsl:template match="DiagramBody">	
		<DiagramBody>
		<xsl:value-of select="$newline" />
			<xsl:copy-of select="ModelActivityElement" />
			<xsl:value-of select="$newline" />

			<xsl:apply-templates select="Nodes" />
			<xsl:value-of select="$newline" />

			<xsl:copy-of select="Links" />
			<xsl:value-of select="$newline" />
		</DiagramBody>
	</xsl:template>

	<!-- *** the DiagramBody applies the Nodes element *** -->	
	<xsl:template match="Nodes">	
		<xsl:element name="{name()}">		
		<xsl:value-of select="$newline" />

			<xsl:variable name="arrAUOperations" select="/NativeMap/GUIBody/GUIOperations/*[BaseAttr/@AutoUpgrade = 'Yes' and not(name() = 'OpCustom')]"  />
			
			<xsl:for-each select="./*">
				<xsl:choose>
					<xsl:when test = "name() = 'ActionNode'">						
						<xsl:call-template name="writeActionNode" >
							<xsl:with-param name="arrAUOperations" select="$arrAUOperations" />									
						</xsl:call-template> 
					</xsl:when>
					<xsl:when test = "name() = 'SubMapNode'">
						<xsl:element name="{name()}">
						<xsl:call-template name="writeAllAttirbutes" />
						<xsl:value-of select="$newline" />											
							<xsl:for-each select="./*">							
								<xsl:call-template name="writeActionNode" >
									<xsl:with-param name="arrAUOperations" select="$arrAUOperations" />									
								</xsl:call-template> 
							</xsl:for-each>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="." />					
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>

			<xsl:apply-templates select="DiagramBody" />
			<xsl:value-of select="$newline" />
		</xsl:element>
	</xsl:template>


	<!-- *** the Nodes applies the ActionNode element *** -->	
	<xsl:template name="writeActionNode" >	
	<xsl:param name="arrAUOperations" />	
		<xsl:element name="{name()}">		
		<xsl:value-of select="$newline" />
			<xsl:copy-of select="ProcessStep" />
			<xsl:value-of select="$newline" />											

			<xsl:call-template name="writeCodeFragment" >
				<xsl:with-param name="arrAUOperations" select="$arrAUOperations" />									
			</xsl:call-template>
			<xsl:value-of select="$newline" />											 
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeCodeFragment" >	
	<xsl:param name="arrAUOperations" />
		<xsl:element name="CodeFragment">				
			<xsl:variable name="uniqID" select="ProcessStep/Node/ModelActivityElement/@UniqID" />
			<xsl:variable name="matchingAUOperation" select="$arrAUOperations[BaseAttr[@UniqIDRef = $uniqID]]" />
			<xsl:choose>
				<xsl:when test="count($matchingAUOperation) = 1 and not(normalize-space($AutoUpgradeOperations) = 'no')" >
					<xsl:attribute name="Type">
						<xsl:value-of select="'XML'" />
					</xsl:attribute>
					<xsl:choose>										
						<xsl:when test="name($matchingAUOperation) = 'OpCopy'">
							<xsl:call-template name="writeXMLMoveCodeFragment" >							
								<xsl:with-param name="AUOpertaion" select ="$matchingAUOperation" />		
							</xsl:call-template>							
						</xsl:when>
						<xsl:when test="name($matchingAUOperation) = 'OpJoin'">
							<xsl:call-template name="writeXMLJoinCodeFragment" >							
								<xsl:with-param name="AUOpertaion" select ="$matchingAUOperation" />		
							</xsl:call-template>
						</xsl:when>
						<xsl:when test="name($matchingAUOperation) = 'OpSplit'">
							<xsl:call-template name="writeXMLSplitCodeFragment" >							
								<xsl:with-param name="AUOpertaion" select ="$matchingAUOperation" />		
							</xsl:call-template>							
						</xsl:when>
						<xsl:when test="name($matchingAUOperation) = 'OpSubMap'">
							<xsl:call-template name="writeXMLSubMapCodeFragment" >							
								<xsl:with-param name="AUOpertaion" select ="$matchingAUOperation" />		
							</xsl:call-template>
						</xsl:when>
						<xsl:when test="name($matchingAUOperation) = 'OpSetValue'">
							<xsl:call-template name="writeXMLSetValueCodeFragment" >							
								<xsl:with-param name="AUOpertaion" select ="$matchingAUOperation" />		
							</xsl:call-template>							
						</xsl:when>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="Type">
						<xsl:value-of select="'Java'" />
					</xsl:attribute>
					<xsl:value-of select="$newline" />											
					<xsl:value-of select="./CodeFragment" />
				</xsl:otherwise>
			</xsl:choose>
			<xsl:value-of select="$newline" />											
		</xsl:element>
	</xsl:template>

	<!-- *** the DLMInfo applies the Properties element *** -->
	<xsl:template match="Properties" >
		<xsl:element name="{name()}">
		<xsl:value-of select="$newline" />
			<xsl:for-each select="Property">
				<xsl:choose>
					<xsl:when test="@Name = 'PropertyValues'">			
						<xsl:call-template name="writePropertyValues" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="." />
					</xsl:otherwise>					
				</xsl:choose>
				<xsl:value-of select="$newline" />
			</xsl:for-each>
		</xsl:element>	
	</xsl:template>

	<!-- *** the NativeMap applies the GUIBody element *** -->
	<xsl:template match="GUIBody" >
		<xsl:element name="{name()}">
		<xsl:value-of select="$newline" />
			<xsl:apply-templates select="GUIBusObjs" />
			<xsl:value-of select="$newline" />

			<xsl:element name="GUIOperations">
				<!-- *** first convert all GUIBusObj/RoleType/RoleOut/VerbAttrs/VerbAttr to OpCustom*** -->
				<xsl:for-each select="GUIBusObjs/GUIBusObj[*]/RoleType/RoleOut/VerbAttrs/VerbAttr[*]">
					<xsl:call-template name="writeConvertedOpCustom" />					
				</xsl:for-each>
				<xsl:for-each select="GUIOperations/*">
					<xsl:call-template name="writeGUIOpertaion" />
				</xsl:for-each>
			</xsl:element>
		</xsl:element>	
	</xsl:template>

	<!-- *** the GUIBody applies the GUIBusObjs element *** -->
	<xsl:template match="GUIBusObjs" >
		<xsl:element name="{name()}">
		<xsl:value-of select="$newline" />
		<xsl:apply-templates select="GUIBusObj" />
		</xsl:element>	
	</xsl:template>

	<!-- *** the GUIBusObjs applies the GUIBusObj element *** -->
	<xsl:template match="GUIBusObj" >
		<xsl:element name="{name()}">
		<xsl:call-template name="writeAllAttirbutes" />
		<xsl:value-of select="$newline" />
			<xsl:apply-templates select="RoleType" />
			<xsl:value-of select="$newline" />			
			<xsl:copy-of select="GUICoord2" />
			<xsl:value-of select="$newline" />			
		</xsl:element>	
	</xsl:template>

	<!-- *** the GUIBusObj applies the RoleType element *** -->
	<xsl:template match="RoleType" >
		<xsl:element name="{name()}">
		<xsl:value-of select="$newline" />
			<xsl:choose>
				<xsl:when test="./*[name() = 'RoleOut']">				 	
					<xsl:apply-templates select="RoleOut" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy-of select="./*/." />
				</xsl:otherwise>
			</xsl:choose>
			<xsl:value-of select="$newline" />			
		</xsl:element>	
	</xsl:template>

	<!-- *** the RoleType applies the RoleOut element *** -->
	<xsl:template match="RoleOut" >
		<xsl:element name="{name()}" />
	</xsl:template>

	<!-- *** the NativeMap applies the Messages element *** -->
	<xsl:template match="Messages" >
		<xsl:element name="{name()}">
		<xsl:value-of select="$newline" />

			<xsl:variable name="treeSpecificMessages">
				<xsl:variable name="strString" select="SpecificMessages" />
				<xsl:copy-of select="java:GetFormatedMessages($objXSLTUtils, $strString)" />				
			</xsl:variable>

			<xsl:variable name="nodeSpecificMessages" select="xalan:nodeset($treeSpecificMessages)" />

			<xsl:element name="CommonMessages">
				<xsl:for-each select="$nodeSpecificMessages/Comment">
					<xsl:value-of select="." />
				</xsl:for-each>
			</xsl:element>
			<xsl:value-of select="$newline" />

			<xsl:call-template name="writeSpecificMessages" >
				<xsl:with-param name="nodeSpecificMessages" select="$nodeSpecificMessages" />
			</xsl:call-template>
			<xsl:value-of select="$newline" /> 
		</xsl:element>	
	</xsl:template>

	<!-- *** the Messages applies the SpecificMessages element *** -->
	<xsl:template name="writeSpecificMessages" >
	<xsl:param name="nodeSpecificMessages" />
		<xsl:element name="SpecificMessages">
			<xsl:attribute name="locale">
				<xsl:value-of select="'en_US'" />
			</xsl:attribute>
			<xsl:value-of select="$newline" />

			<xsl:for-each select="$nodeSpecificMessages/Msg">
				<xsl:copy-of select="." />				
			</xsl:for-each>

		</xsl:element>
	</xsl:template>

	<!-- 
	***************************************************************************************************************************************************************************
	Utility template functions.
	***************************************************************************************************************************************************************************
	-->

	<!-- *** copies all source element's attribute name and value pairs to the destination element *** -->
	<xsl:template name="writeAllAttirbutes">
		<xsl:for-each select="@*">	
			<xsl:attribute name="{name()}">
				<xsl:value-of select="." />
			</xsl:attribute>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="writePropertyValues">
		<xsl:element name="{name()}">
		<xsl:call-template name="writeAllAttirbutes" />
		<xsl:value-of select="$newline" />
			<Attributes>
				<xsl:for-each select="Attributes/Attribute">
					<xsl:copy-of select="." />
				</xsl:for-each>
				<xsl:element name="Attribute">
				<xsl:attribute name="Name">
					<xsl:value-of select="'MAPPING_DIRECTION'" />
				</xsl:attribute>
				<xsl:attribute name="Type">
					<xsl:value-of select="'0'" />
				</xsl:attribute>
					<Value> 0 </Value>
					<Desc />
				</xsl:element>
			</Attributes>
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeGUIOpertaion">
		<xsl:element name="{name()}">		
		<xsl:value-of select="$newline" />
		<xsl:variable name="strParentElementName" select="name()" />
			<xsl:for-each select="./*">
				<xsl:choose>
					<xsl:when test= "name() = 'BaseAttr'">
						<xsl:call-template name="writeBaseAttr"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="./." />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeBaseAttr">
		<xsl:element name="{name()}">
			<xsl:attribute name="UniqIDRef">
				<xsl:value-of select="@UniqIDRef" />
			</xsl:attribute>
			<xsl:attribute name="AutoUpgrade">
				<xsl:choose>
					<xsl:when test="name(../) = 'OpCustom'">
						<xsl:value-of select="'No'" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="normalize-space($AutoUpgradeOperations) = 'no'">
								<xsl:value-of select="'No'" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="@AutoUpgrade" />					
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			<xsl:attribute name="DisplayOrder">
				<xsl:value-of select="@DisplayOrder" />
			</xsl:attribute>
			<xsl:attribute name="BusObjVersion">
				<xsl:value-of select="@BusObjVersion" />
			</xsl:attribute>
			<xsl:attribute name="ExecutionOrder">
				<xsl:value-of select="@ExecutionOrder" />
			</xsl:attribute>
			<xsl:value-of select="$newline" />
			<xsl:for-each select="./*">
				<xsl:choose>
					<xsl:when test= "name() = 'BOPathDst' or  name() = 'BOPathSrcs'">
						<xsl:call-template name="writeBOPathDstSrcs" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="./." />
					</xsl:otherwise>
				</xsl:choose>					
			</xsl:for-each>
		</xsl:element>
	</xsl:template>

	<xsl:template name="writeConvertedOpCustom">
		<OpCustom>
			<xsl:element name="BaseAttr">
				<xsl:attribute name="UniqIDRef">
					<xsl:value-of select="@UniqIDRef" />
				</xsl:attribute>
				<xsl:attribute name="AutoUpgrade">
					<xsl:value-of select="'No'" />
				</xsl:attribute>
				<xsl:attribute name="DisplayOrder">
					<xsl:value-of select="'0'" />
				</xsl:attribute>
				<xsl:attribute name="BusObjVersion">
					<xsl:value-of select="'NotKnown'" />
				</xsl:attribute>
				<xsl:attribute name="ExecutionOrder">
					<xsl:value-of select="'-1'" />
				</xsl:attribute>
				<BOPathDst>
					<xsl:element name="BOPath">
						<xsl:attribute name="AttrType">
							<xsl:value-of select="'String'" />
						</xsl:attribute>
						<xsl:attribute name="AttrClass">
							<xsl:value-of select="'TypeVerb'" />
						</xsl:attribute>
						<xsl:attribute name="AttrCardinality">
							<xsl:value-of select="'1'" />
						</xsl:attribute>						
						<Path>
							<xsl:value-of select="./Path" />
						</Path>
					</xsl:element>
				</BOPathDst>
				<BOPathSrcs />
				<Comment>
					<xsl:value-of select="./Comment" />						
				</Comment>
			</xsl:element>
		</OpCustom>
	</xsl:template>
	

	<xsl:template name="writeBOPathDstSrcs">
		<xsl:element name="{name()}">
		<xsl:value-of select="$newline" />					
			<xsl:for-each select="./BOPath">
				<xsl:element name="{name()}" >					
					<xsl:call-template name="writeAllBOPathAttribs" />
					<xsl:value-of select="$newline" />
					<xsl:copy-of select="./*" />
				</xsl:element>																	
			</xsl:for-each>
		</xsl:element>
	</xsl:template>
	
	<xsl:template name="writeAllBOPathAttribs">
		<xsl:attribute name="AttrType">
			<xsl:value-of select="@AttrType" />
		</xsl:attribute>
		<xsl:attribute name="AttrClass">
			<xsl:choose>
				<xsl:when test="@AttrClass ='TypeBOSingle' or @AttrClass ='TypeBOMultiple'">
					<xsl:value-of select="'TypeBO'" />
				</xsl:when>
				<xsl:when test="@AttrClass ='TypeBasic'">
					<xsl:variable name="strVarName" select="substring-before(normalize-space(./Path), '.')" />
					<xsl:choose>
						<xsl:when test="not($strVarName = '') and count(./../../../../../GUIBusObjs/GUIBusObj[@VarName = $strVarName]/RoleType/RoleTmp) &gt; 0">
							<xsl:value-of select="'TypeTempVar'" />																										
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="@AttrClass" />															
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="@AttrClass" />								
				</xsl:otherwise>
			</xsl:choose>						
		</xsl:attribute>
		<xsl:attribute name="AttrCardinality">
			<xsl:choose>
				<xsl:when test="@AttrClass ='TypeBasic' or @AttrClass ='TypeBOSingle' or @AttrClass ='TypeTempVar'">
					<xsl:value-of select="'1'" />
				</xsl:when>
				<xsl:when test="@AttrClass ='TypeBOMultiple'">
					<xsl:value-of select="'N'" />
				</xsl:when>
				<xsl:when test="@AttrClass ='TypeTempVar'">
					<xsl:value-of select="'1'" />
				</xsl:when>
				<xsl:when test="@AttrClass ='TypeVerb'">
					<xsl:value-of select="'1'" />
				</xsl:when>
			</xsl:choose>
		</xsl:attribute>
	</xsl:template>

	<xsl:template name="writeXMLMoveCodeFragment">
	<xsl:param name="AUOpertaion" />				
		&lt;snp:codeUnit snp:id="_0" xmlns:snp="http://www.ibm.com/websphere/crossworlds/Sapphire/CodeUnit">
			&lt;snp:call-template snp:type="Translator/Map/Move" snp:id="_1">
				&lt;snp:with-param snp:name="fromAttr" snp:type="BusObjAttr" snp:id="_2">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathSrcs/BOPath[1]" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="toAttr" snp:type="BusObjAttr" snp:id="_3">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathDst/BOPath" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
			&lt;/snp:call-template>
		&lt;/snp:codeUnit>
	</xsl:template>


	<xsl:template name="writeXMLJoinCodeFragment">
	<xsl:param name="AUOpertaion" />				
		&lt;snp:codeUnit snp:id="_0" xmlns:snp="http://www.ibm.com/websphere/crossworlds/Sapphire/CodeUnit">
			&lt;snp:call-template snp:type="Translator/Map/Join" snp:id="_1">
				&lt;snp:with-param snp:name="fromAttr" snp:type="BusObjAttr" snp:id="_2">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathSrcs/BOPath[1]" />
						</xsl:call-template>
					&lt;/snp:value>
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathSrcs/BOPath[2]" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="toAttr" snp:type="BusObjAttr" snp:id="_3">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathDst/BOPath" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="delimiter" snp:type="String" snp:id="_3">
					<xsl:for-each select="$AUOpertaion/Delimiters/Delimiter">
						&lt;snp:value><xsl:value-of select="."/>&lt;/snp:value>
					</xsl:for-each>
				&lt;/snp:with-param>
			&lt;/snp:call-template>
		&lt;/snp:codeUnit>
	</xsl:template>

	<xsl:template name="writeXMLSplitCodeFragment">
	<xsl:param name="AUOpertaion" />				
		&lt;snp:codeUnit snp:id="_0" xmlns:snp="http://www.ibm.com/websphere/crossworlds/Sapphire/CodeUnit">
			&lt;snp:call-template snp:type="Translator/Map/Split" snp:id="_1">
				&lt;snp:with-param snp:name="fromAttr" snp:type="BusObjAttr" snp:id="_2">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathSrcs/BOPath[1]" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="toAttr" snp:type="BusObjAttr" snp:id="_3">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathDst/BOPath" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="splitIndex" snp:type="int" snp:id="_3">
					&lt;snp:value><xsl:value-of select="$AUOpertaion/SplitIndex" />&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="separator" snp:type="String" snp:id="_3">
					&lt;snp:value><xsl:value-of select="$AUOpertaion/Separator" />&lt;/snp:value>
				&lt;/snp:with-param>
			&lt;/snp:call-template>
		&lt;/snp:codeUnit>
	</xsl:template>

	<xsl:template name="writeXMLSubMapCodeFragment">
	<xsl:param name="AUOpertaion" />				
		&lt;snp:codeUnit snp:id="_0" xmlns:snp="http://www.ibm.com/websphere/crossworlds/Sapphire/CodeUnit">
			&lt;snp:call-template snp:type="Translator/Map/Submap" snp:id="_1">
				&lt;snp:with-param snp:name="fromAttr" snp:type="BusObjAttr" snp:id="_2">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathSrcs/BOPath[1]" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="toAttr" snp:type="BusObjAttr" snp:id="_3">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathDst/BOPath" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="SubmapName" snp:type="String" snp:id="_3">
					&lt;snp:value><xsl:value-of select="$AUOpertaion/SubMapName" />&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="condition" snp:type="String" snp:id="_3">
					&lt;snp:value><xsl:value-of select="$AUOpertaion/SubMapCond" />&lt;/snp:value>
				&lt;/snp:with-param>
			&lt;/snp:call-template>
		&lt;/snp:codeUnit>
	</xsl:template>


	<xsl:template name="writeXMLSetValueCodeFragment">
	<xsl:param name="AUOpertaion" />				
		&lt;snp:codeUnit snp:id="_0" xmlns:snp="http://www.ibm.com/websphere/crossworlds/Sapphire/CodeUnit">
			&lt;snp:call-template snp:type="Translator/Map/SetValue" snp:id="_1">
				&lt;snp:with-param snp:name="toAttr" snp:type="BusObjAttr" snp:id="_3">
					&lt;snp:value>
						<xsl:call-template name ="writeBusObjAttributeInXMLCodeFragment">
							<xsl:with-param name="nodeBOPath" select="$AUOpertaion/BaseAttr/BOPathDst/BOPath" />
						</xsl:call-template>
					&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="value" snp:type="String" snp:id="_3">
					&lt;snp:value><xsl:value-of select="$AUOpertaion/SetValueString" />&lt;/snp:value>
				&lt;/snp:with-param>
				&lt;snp:with-param snp:name="valueIsString" snp:type="boolean" snp:id="_3">
					&lt;snp:value><xsl:choose>
							<xsl:when test="normalize-space($AUOpertaion/ValueIsString)=1"><xsl:value-of select="'true'"/></xsl:when>
							<xsl:otherwise><xsl:value-of select="'false'"/></xsl:otherwise></xsl:choose>&lt;/snp:value>
				&lt;/snp:with-param>
			&lt;/snp:call-template>
		&lt;/snp:codeUnit>
	</xsl:template>

	<xsl:template name="writeOtherBusObjAttributeinXMLCodeFragment">
	<xsl:param name="strAttrClass" />
		<xsl:choose >
			<xsl:when test="$strAttrClass = 'TypeBasic'">
				&lt;IsBO>false&lt;/IsBO>
				&lt;IsVerb>false&lt;/IsVerb>
				&lt;IsMultiCard>false&lt;/IsMultiCard>
				&lt;IsTempVar>false&lt;/IsTempVar>
			</xsl:when>
			<xsl:when test="$strAttrClass = 'TypeBOSingle'">
				&lt;IsBO>true&lt;/IsBO>
				&lt;IsVerb>false&lt;/IsVerb>
				&lt;IsMultiCard>false&lt;/IsMultiCard>
				&lt;IsTempVar>false&lt;/IsTempVar>
			</xsl:when>
			<xsl:when test="$strAttrClass = 'TypeBOMultiple'">
				&lt;IsBO>true&lt;/IsBO>
				&lt;IsVerb>false&lt;/IsVerb>
				&lt;IsMultiCard>true&lt;/IsMultiCard>
				&lt;IsTempVar>false&lt;/IsTempVar>
			</xsl:when>
			<xsl:when test="$strAttrClass = 'TypeTempVar'">
				&lt;IsBO>false&lt;/IsBO>
				&lt;IsVerb>false&lt;/IsVerb>
				&lt;IsMultiCard>false&lt;/IsMultiCard>
				&lt;IsTempVar>true&lt;/IsTempVar>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="writeBusObjAttributeInXMLCodeFragment">
	<xsl:param name="nodeBOPath" />
		&lt;BOAttr>
			&lt;BusObjName><xsl:value-of select="substring-before($nodeBOPath/Path, '.')" />&lt;/BusObjName>
			&lt;AttrPath><xsl:value-of select="substring-after($nodeBOPath/Path, '.')" />&lt;/AttrPath>
			&lt;AttrType><xsl:value-of select="$nodeBOPath/@AttrType" />&lt;/AttrType>

			<xsl:variable name="strAttrClass">
				<xsl:variable name="strVarName" select="substring-before(normalize-space($nodeBOPath/Path), '.')" />
				<xsl:choose>
					<xsl:when test="not($strVarName = '') and $nodeBOPath/@AttrClass = 'TypeBasic' and count($nodeBOPath/../../../../../GUIBusObjs/GUIBusObj[@VarName = $strVarName]/RoleType/RoleTmp) &gt; 0">
							<xsl:value-of select="'TypeTempVar'" />																										
					</xsl:when>			
					<xsl:otherwise>
						<xsl:value-of select="$nodeBOPath/@AttrClass" />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:call-template name="writeOtherBusObjAttributeinXMLCodeFragment" >
				<xsl:with-param name="strAttrClass" select="$strAttrClass" />
			</xsl:call-template>
		&lt;/BOAttr>
	</xsl:template>

</xsl:stylesheet>
	
