<?xml version="1.0" encoding="UTF-8"?>

<!--
	* Licensed Materials - Property of IBM
	* 5724-C11, 5724-C13, 5724-D17
	* (C) Copyright IBM Corporation 1997, 2003. All Rights Reserved.
	* US Government Users Restricted Rights- Use, duplication or disclosure
	* restricted by GSA ADP Schedule Contract with IBM Corp.
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:tns="http://tempuri.org/cwld2bpel/wsdl" xmlns:slt="http://schemas.xmlsoap.org/ws/2002/06/service-link/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:pt="http://tempuri.org/cwld2bpel/wsdl/Partner" xmlns:wFT="http://schemas.xmlsoap.org/wsbp/Faults" xmlns:wswf="http://schemas.xmlsoap.org/ws/2002/07/wswf/">
<xsl:output method="xml" indent="yes" />
<!-- 
	***************************************************************************************************************************************************************************
	Fills in the BPEL definitions - Partners, Containers and the top level flow element.
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="/">
		<xsl:comment>Generated by IBM CrossWorlds</xsl:comment>
		<xsl:element name="process" namespace="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
			<xsl:copy-of select="document('')/*/namespace::tns" />
			<xsl:copy-of select="document('')/*/namespace::slt" />
			<xsl:copy-of select="document('')/*/namespace::xsd" />
			<xsl:copy-of select="document('')/*/namespace::pt" />
			<xsl:copy-of select="document('')/*/namespace::wFT" />
			<xsl:copy-of select="document('')/*/namespace::wswf" />
		<!--
		<process xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
			-->
			<xsl:attribute name="suppressJoinFailure" >yes</xsl:attribute>
			<xsl:attribute name="enableInstanceCompensation" >no</xsl:attribute>
			<xsl:attribute name="targetNamespace">http://tempuri.org/cwld2bpel</xsl:attribute>
			<xsl:attribute name="name" ><xsl:value-of select="/CollabTemplate/@Name"/></xsl:attribute>
			<xsl:call-template name="writeGlobals" />
			<extension xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/"></extension>
			<partners xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
				<partner>
					<xsl:attribute name="name">caller</xsl:attribute>
					<xsl:attribute name="serviceLinkType"><xsl:value-of select="concat('slt:',CollabTemplate/@Name,'SLT')"></xsl:value-of></xsl:attribute>
				</partner>
				<xsl:apply-templates select="/CollabTemplate/Scenarios/Scenario/ModelScenario/Diagram/DiagramBody/Nodes//ServiceNode" mode="Partner"/>
			</partners>
			<containers xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
				<xsl:apply-templates select="/CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef" mode="Container"></xsl:apply-templates>
			</containers>
			<flow xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
				<xsl:call-template name="writeActivityStdAttributes" >
					<xsl:with-param name="name"><xsl:value-of select="CollabTemplate/@Name"></xsl:value-of></xsl:with-param>
					<xsl:with-param name="joinCondition"></xsl:with-param>
					<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="writeMainFlowLinks"></xsl:call-template>
				<xsl:call-template name="writePick"/>
				<xsl:apply-templates select="/CollabTemplate/Scenarios/Scenario" />
			</flow>
		<!--
		</process>
		-->
		</xsl:element>
	</xsl:template>	


<!-- 

	***************************************************************************************************************************************************************************
	Fills in the globals within a FlowModel
	Some standard imports have been included
	Some standard objects (triggeringBusObj...) have been included.
	***************************************************************************************************************************************************************************
-->
	
	<xsl:template name="writeGlobals" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<wswf:globals wswf:language="Java">

			// Begin Standard Imports
			import CxCommon.CwDBConnection.*;
			import Collaboration.BaseCollaboration;
			import Collaboration.CollaborationException;
			import Collaboration.BusObj;
			import Collaboration.BusObjArray;
			// End Standard Imports

			// Begin Collaboration Properties (Definitions, Imports ...)
			<!--xsl:apply-templates select="/CollabTemplate/TemplateDefinition/Properties/Property/Attributes/Attribute" /-->
			<xsl:apply-templates select="/CollabTemplate/TemplateDefinition/Properties/Property" />
			// End Collaboration Properties
			<xsl:text>&#xA;</xsl:text>
			<xsl:apply-templates select="/CollabTemplate/TemplateDefinition" />
			<xsl:text>&#xA;</xsl:text>

			// Begin Cwld System defined variables
			 public BusObj triggeringBusObj;
			 public CollaborationException currentException;
			// End Cwld System defined variables

			// counter for while loops
			 public int iteratorcounter = 0;
		</wswf:globals>
	</xsl:template>	
<!--
	***************************************************************************************************************************************************************************
	Fills in the Globals for Property
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="Property" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
			<xsl:variable name="attribType" select="@Name"/>
			// Begin <xsl:value-of select="$attribType"/>
			<xsl:apply-templates select="Attributes/Attribute"/>
			// End <xsl:value-of select="$attribType"/>
	</xsl:template>
<!--
	***************************************************************************************************************************************************************************
	Fills in the Globals for Property Values
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="Attribute" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
			<xsl:variable name="attribType" select="../../@Name"/>
			<xsl:choose>
				<xsl:when test="$attribType='PropertyValues'">
						<xsl:text>&#xA;</xsl:text>
						<xsl:value-of select="@Name"></xsl:value-of>=<xsl:value-of select="Value" />				
					</xsl:when>
				<xsl:otherwise >
						<xsl:text>&#xA;</xsl:text>
						<xsl:value-of select="Value" />					
				</xsl:otherwise>
			</xsl:choose>
	</xsl:template>

<!--
	***************************************************************************************************************************************************************************
	Fills in the Globals for TemplateDefinition/GeneratedVars
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="TemplateDefinition" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		// Begin GeneratedVars
		<xsl:value-of select="GeneratedVars" />
		// End GeneratedVars
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Commands for Diagram/Declarations
	***************************************************************************************************************************************************************************
-->	
	<xsl:template match="Diagram/Declaration" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:if test="boolean(normalize-space(Section1))">
			<xsl:value-of select="Section1" />
			<xsl:text>&#xA;</xsl:text>
		</xsl:if>				
		<xsl:if test="boolean(normalize-space(Section2))">
			<xsl:value-of select="Section2" />
			<xsl:text>&#xA;</xsl:text>
		</xsl:if>				
	</xsl:template>


<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Pick Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template name="writePick" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<pick>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name">start</xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:attribute name="createInstance">Yes</xsl:attribute>
			<xsl:call-template name="writeSource">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
				<xsl:with-param name="linktype">7</xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeTarget">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writePickOnMessage"></xsl:call-template>
		</pick>
	</xsl:template>
<!-- 
	***************************************************************************************************************************************************************************
	Fills in the WSBP Process
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="Scenario" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
			<xsl:variable name="ScenarioName" select="@Name"></xsl:variable>
			<xsl:variable name="DiagramRef" select="@DiagramRef"></xsl:variable>
			<xsl:apply-templates select="ModelScenario/Diagram[@Name=$DiagramRef]" mode="Flow"/>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Containers
	Assumption : Each container corresponds to a BusinessObject
	container.name = /CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef/BusObjRef[@Name] + "BusObj"
	container.messageType = /CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef/BusObjRef[@BusObjType]
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="BusObjRef" mode="Container" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<container>
			<xsl:attribute name="name"><xsl:value-of select="@Name"/></xsl:attribute>  
			<xsl:attribute name="messageType"><xsl:value-of select="concat('tns:',@BusObjType,'Msg')"/></xsl:attribute>  
		</container>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Containers
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="Property/Attributes/Attribute" mode="Container" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="PropertyName" select="../../@Name"></xsl:variable>
		<container>
			<xsl:attribute name="name"><xsl:value-of select="concat($PropertyName,'_',@Name,'Container')"/></xsl:attribute>  
		</container>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Containers
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="Nodes/IteratorNode" mode="Container" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="ContainerName">
			<xsl:call-template name="getIteratorNodeContainerName"></xsl:call-template>
		</xsl:variable>
		<container>
			<xsl:attribute name="name"><xsl:value-of select="concat($ContainerName,'Container')"/></xsl:attribute>  
		</container>
	</xsl:template>
<!--
	***************************************************************************************************************************************************************************
	Fills in the Partners
	Assumption : Each ServiceNode in a cwld collaboration corresponds to a unique partner
	serviceProviderType.name=ProcessStep/Node/ModelActivityElement/Label + ProcessStep/Node/ModelActivityElement/@UniqID + "Partner"
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="ServiceNode" mode="Partner" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<partner>
			<xsl:attribute name="name"><xsl:value-of select="concat(normalize-space(ProcessStep/Node/ModelActivityElement/Label),ProcessStep/Node/ModelActivityElement/@UniqID,'Partner')"></xsl:value-of></xsl:attribute>
			<xsl:attribute name="serviceLinkType"><xsl:value-of select="concat('slt:',RegBusObjRefName,'SLT')"></xsl:value-of></xsl:attribute>
		</partner>
	</xsl:template>

<!--
	***************************************************************************************************************************************************************************
	Fills in the Main Flow
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="Diagram" mode="Flow" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<flow>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name"><xsl:value-of select="@Name"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:attribute name="name" ><xsl:value-of select="@Name"></xsl:value-of></xsl:attribute>
			<links>
				<xsl:apply-templates select="DiagramBody/Links/TransitionLink/Link/Connect" mode="link"/>
				<xsl:apply-templates select="DiagramBody/Links/ExceptionLink/Link/Connect" mode="link"/>
				<xsl:apply-templates select="DiagramBody/Links/MessageLink/Link/Connect" mode="link"/>
			</links>
			<wswf:script wswf:language="Java">
				// Flow Declarations
				<xsl:apply-templates select="Declaration"></xsl:apply-templates>
			</wswf:script>
			<xsl:apply-templates select="DiagramBody/Nodes/ActionNode" mode="Flow"/>
			<xsl:apply-templates select="DiagramBody/Nodes/IteratorNode" mode="Flow"/>
			<xsl:apply-templates select="DiagramBody/Nodes/FailureEndNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/InitialNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/SuccessEndNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes//ServiceNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/SubDiagramNode"/>
		</flow>		
	</xsl:template>

<!--
	***************************************************************************************************************************************************************************
	Fills in the SubDiagram  Flow
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="Diagram" mode="SubDiagramFlow" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
	<xsl:param name="SubDiagUniqID"></xsl:param>
		<flow>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name"><xsl:value-of select="@Name"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:attribute name="name" ><xsl:value-of select="@Name"></xsl:value-of></xsl:attribute>
			<xsl:call-template name="writeSource">
				<xsl:with-param name="UniqID" select="$SubDiagUniqID"></xsl:with-param>
				<xsl:with-param name="linktype">7</xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeTarget">
				<xsl:with-param name="UniqID" select="$SubDiagUniqID"></xsl:with-param>
			</xsl:call-template>
			<links>
				<xsl:apply-templates select="DiagramBody/Links/TransitionLink/Link/Connect" mode="link"/>
				<xsl:apply-templates select="DiagramBody/Links/ExceptionLink/Link/Connect" mode="link"/>
				<xsl:apply-templates select="DiagramBody/Links/MessageLink/Link/Connect" mode="link"/>
			</links>
			<wswf:script wswf:language="Java">
				// Flow Declarations
				<xsl:apply-templates select="Declaration"></xsl:apply-templates>
			</wswf:script>
			<xsl:apply-templates select="DiagramBody/Nodes/InitialNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/ActionNode" mode="Flow"/>
			<xsl:apply-templates select="DiagramBody/Nodes/IteratorNode" mode="Flow"/>
			<xsl:apply-templates select="DiagramBody/Nodes//ServiceNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/SubDiagramNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/SuccessEndNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/FailureEndNode"/>
		</flow>		
	</xsl:template>

<!--
	***************************************************************************************************************************************************************************
	Fills in the Iterator Flow
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="Diagram" mode="IteratorFlow" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<flow>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name"><xsl:value-of select="@Name"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:attribute name="name" ><xsl:value-of select="@Name"></xsl:value-of></xsl:attribute>
			<links>
				<xsl:apply-templates select="DiagramBody/Links/TransitionLink/Link/Connect" mode="link"/>
				<xsl:apply-templates select="DiagramBody/Links/ExceptionLink/Link/Connect" mode="link"/>
				<xsl:apply-templates select="DiagramBody/Links/MessageLink/Link/Connect" mode="link"/>
			</links>
			<wswf:script wswf:language="Java">
				// Flow Declarations
				<xsl:apply-templates select="Declaration"></xsl:apply-templates>
			</wswf:script>
			<xsl:apply-templates select="DiagramBody/Nodes/InitialNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/ActionNode" mode="Flow"/>
			<xsl:apply-templates select="DiagramBody/Nodes/IteratorNode" mode="Flow"/>
			<xsl:apply-templates select="DiagramBody/Nodes//ServiceNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/SubDiagramNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/SuccessEndNode"/>
			<xsl:apply-templates select="DiagramBody/Nodes/FailureEndNode"/>
		</flow>		
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Activity definition for an Initial Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="InitialNode" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<empty>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name" ><xsl:value-of select="concat(normalize-space(PseudoState/Node/ModelActivityElement/Label),PseudoState/Node/ModelActivityElement/@UniqID)"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeSource">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
				<xsl:with-param name="linktype">7</xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeTarget">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
			</xsl:call-template>
		</empty>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Activity definition for an Action Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="ActionNode" mode="Flow" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
      <xsl:variable name="scenario" select="ancestor::*[5]/@Name"/>
		<wswf:script wswf:language="Java">
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name" ><xsl:value-of select="concat(normalize-space(ProcessStep/Node/ModelActivityElement/Label),ProcessStep/Node/ModelActivityElement/@UniqID)"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<!--
				if there is a service call from this node, then writeSource should only have 1 link to the service node i.e.
				if there is a ServiceNode called from this ActionNode
					Pass 'linktype='4' parameter to writeSource
				else
					Pass 'linktype='7' parameter to writeSource
			-->
			<xsl:choose>
				<xsl:when test="//MessageLink/Link/Connect/@From=ProcessStep/Node/ModelActivityElement/@UniqID">
					<xsl:call-template name="writeSource">
						<xsl:with-param name="UniqID" select="ProcessStep/Node/ModelActivityElement/@UniqID"></xsl:with-param>
						<xsl:with-param name="linktype">4</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="writeSource">
						<xsl:with-param name="UniqID" select="ProcessStep/Node/ModelActivityElement/@UniqID"></xsl:with-param>
						<xsl:with-param name="linktype">7</xsl:with-param>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:call-template name="writeTarget">
				<xsl:with-param name="UniqID" select="ProcessStep/Node/ModelActivityElement/@UniqID"></xsl:with-param>
			</xsl:call-template>
			<xsl:text>&#xA;</xsl:text>
			<xsl:value-of select="CodeFragment"></xsl:value-of>
			<xsl:text>&#xA;</xsl:text>
		</wswf:script>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Activity definition for an Iterator Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="IteratorNode" mode="Flow" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="SubDiagRef"><xsl:value-of select="CompositeNode/@DiagramRef"/></xsl:variable>
		<xsl:variable name="SubDiagName">
				<xsl:value-of select="/CollabTemplate/Scenarios/Scenario/ModelScenario/Diagram[@Name=$SubDiagRef]/ModelStructureElement/@Name"/>
		</xsl:variable>
		<sequence>
				<xsl:call-template name="writeTarget">
					<xsl:with-param name="UniqID" select="CompositeNode/ProcessStep/Node/ModelActivityElement/@UniqID"></xsl:with-param>
				</xsl:call-template>
			<wswf:script wswf:language="Java">
				<xsl:value-of select="IteratorVariable" />
			</wswf:script>
			<xsl:choose>
				<xsl:when test="@Type='Loop'">
					<wswf:script wswf:language="Java">
						<xsl:value-of select="Start" />
					</wswf:script>
				</xsl:when>	
				<xsl:otherwise>
					<wswf:script wswf:language="Java">
						iteratorcounter = 0;
					</wswf:script>
				</xsl:otherwise>	
			</xsl:choose>
			<while>
				<xsl:call-template name="writeActivityStdAttributes" >
					<xsl:with-param name="name" ><xsl:value-of select="concat(normalize-space	(CompositeNode/ProcessStep/Node/ModelActivityElement/Label),CompositeNode/ProcessStep/Node/ModelActivityElement/@UniqID)"></xsl:value-of></xsl:with-param>
					<xsl:with-param name="joinCondition"></xsl:with-param>
					<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
				</xsl:call-template>
				<xsl:variable name="BusinessObjectName">
					<xsl:value-of select="substring-before(ThruThisObject,'.')"></xsl:value-of>
				</xsl:variable>
				<xsl:variable name="BusinessObjectPartName">
					<xsl:value-of select="substring-after(ThruThisObject,'.')"></xsl:value-of>
				</xsl:variable>
				<xsl:variable name="iteratorCondition">
					<xsl:choose>
						<xsl:when test="@Type='Loop'">
							<xsl:value-of select="Condition"/>
						</xsl:when>	
						<xsl:when test="@Type='Attribute'">
							<xsl:value-of select="concat(ThruThisObject,'.get','(iteratorcounter) != null')"/>
						</xsl:when>	
						<xsl:when test="@Type='BusObj'">
							<xsl:value-of select="concat($BusinessObjectName,'.get',$BusinessObjectPartName,'(iteratorcounter) != null')"/>
						</xsl:when>	
						<xsl:otherwise>
							<xsl:value-of select="concat($BusinessObjectName,'.get',$BusinessObjectPartName,'(iteratorcounter) != null')"/>
						</xsl:otherwise>	
					</xsl:choose>
				</xsl:variable>
				<xsl:attribute name="condition"><xsl:value-of select="$iteratorCondition"/></xsl:attribute>
				<xsl:call-template name="writeSource">
					<xsl:with-param name="UniqID" select="CompositeNode/ProcessStep/Node/ModelActivityElement/@UniqID"></xsl:with-param>
					<xsl:with-param name="linktype">7</xsl:with-param>
				</xsl:call-template>
				<xsl:apply-templates select="/CollabTemplate/Scenarios/Scenario/ModelScenario/Diagram[@Name=$SubDiagRef]" mode="IteratorFlow"/>
				<xsl:choose>
					<xsl:when test="@Type='Loop'">
						<wswf:script wswf:language="Java">
							<xsl:value-of select="Increment" />
						</wswf:script>
					</xsl:when>	
					<xsl:otherwise>
						<wswf:script wswf:language="Java">
							iteratorcounter++;
						</wswf:script>
					</xsl:otherwise>	
				</xsl:choose>
			</while>
		</sequence>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Activity definition for an FailureEnd Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="FailureEndNode" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<throw>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name" ><xsl:value-of select="concat(normalize-space(PseudoState/Node/ModelActivityElement/Label),PseudoState/Node/ModelActivityElement/@UniqID)"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:attribute name="faultName"><xsl:value-of select="concat('wFT:',normalize-space(PseudoState/Node/ModelActivityElement/Label),PseudoState/Node/ModelActivityElement/@UniqID,'Fault')"></xsl:value-of></xsl:attribute>
			<xsl:call-template name="writeSource">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
				<xsl:with-param name="linktype">7</xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeTarget">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
			</xsl:call-template>
		</throw>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Activity definition for an SuccessEnd Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="SuccessEndNode" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<empty>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name" ><xsl:value-of select="concat(normalize-space(PseudoState/Node/ModelActivityElement/Label),PseudoState/Node/ModelActivityElement/@UniqID)"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeSource">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
				<xsl:with-param name="linktype">7</xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeTarget">
				<xsl:with-param name="UniqID" select="PseudoState/Node/ModelActivityElement/@UniqID"></xsl:with-param>
			</xsl:call-template>
		</empty>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Activity definition for an Service Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="ServiceNode" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="UniqID" select="ProcessStep/Node/ModelActivityElement/@UniqID"/>
		<invoke>
			<xsl:call-template name="writeActivityStdAttributes" >
				<xsl:with-param name="name" ><xsl:value-of select="concat(normalize-space(ProcessStep/Node/ModelActivityElement/Label),$UniqID)"></xsl:value-of></xsl:with-param>
				<xsl:with-param name="joinCondition"></xsl:with-param>
				<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
			</xsl:call-template>
			<xsl:attribute name="partner"><xsl:value-of select="concat(normalize-space(ProcessStep/Node/ModelActivityElement/Label),$UniqID,'Partner')"></xsl:value-of></xsl:attribute>
			<xsl:attribute name="portType" >pt:<xsl:value-of select="concat(RegBusObjRefName,'PT')"></xsl:value-of></xsl:attribute>
			<xsl:attribute name="operation" ><xsl:value-of select="RegBusObjVerb"></xsl:value-of></xsl:attribute>
			<xsl:attribute name="inputContainer"><xsl:value-of select="RegBusObjName"></xsl:value-of></xsl:attribute>
			<xsl:attribute name="outputContainer"><xsl:value-of select="RegBusObjRefName"></xsl:value-of></xsl:attribute>
			<!--
				writeSource should have all the source links that should have been in the action node which called this service node i.e.
				Find the calling action Node
				Pass the UniqID of the action Node to writeSource with parameter 'linktype=3'
			-->
			<xsl:variable name="CallingNodeID">
			<xsl:value-of select="//MessageLink/Link/Connect[@To=$UniqID]/@From"></xsl:value-of>				
			</xsl:variable>
			<xsl:call-template name="writeSource">
				<xsl:with-param name="UniqID" select="$CallingNodeID"></xsl:with-param>
				<xsl:with-param name="linktype">3</xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="writeTarget">
				<xsl:with-param name="UniqID" select="$UniqID"></xsl:with-param>
			</xsl:call-template>
			<xsl:if test="boolean(normalize-space(CmpBusObjRefName))">
				<compensationHandler>
					<invoke>
						<xsl:call-template name="writeActivityStdAttributes" >
							<xsl:with-param name="name" ><xsl:value-of select="concat(normalize-space(CmpBusObjRefName),normalize-space(CmpBusObjVerb),$UniqID)"></xsl:value-of></xsl:with-param>
							<xsl:with-param name="joinCondition"></xsl:with-param>
							<xsl:with-param name="suppressJoinFailure"></xsl:with-param>
						</xsl:call-template>
						<xsl:attribute name="partner"><xsl:value-of select="concat(normalize-space(ProcessStep/Node/ModelActivityElement/Label),$UniqID,'Partner')"></xsl:value-of></xsl:attribute>
						<xsl:attribute name="portType" ><xsl:value-of select="concat('pt:',CmpBusObjRefName,'PT')"></xsl:value-of></xsl:attribute>
						<xsl:attribute name="operation" ><xsl:value-of select="CmpBusObjVerb"></xsl:value-of></xsl:attribute>
						<xsl:attribute name="inputContainer"><xsl:value-of select="CmpBusObjName"></xsl:value-of></xsl:attribute>
						<xsl:attribute name="outputContainer"><xsl:value-of select="CmpBusObjRefName"></xsl:value-of></xsl:attribute>
					</invoke>
				</compensationHandler>
			</xsl:if>
		</invoke>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Activity definition for an SubDiagram Node
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="SubDiagramNode" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="SubDiagRef"><xsl:value-of select="CompositeNode/@DiagramRef"/></xsl:variable>
		<xsl:variable name="SubDiagUniqID"><xsl:value-of select="CompositeNode/ProcessStep/Node/ModelActivityElement/@UniqID"/></xsl:variable>
		<xsl:variable name="SubDiagName">
				<xsl:value-of select="/CollabTemplate/Scenarios/Scenario/ModelScenario/Diagram[@Name=$SubDiagRef]/ModelStructureElement/@Name"/>
		</xsl:variable>
		<xsl:apply-templates select="/CollabTemplate/Scenarios/Scenario/ModelScenario/Diagram[@Name=$SubDiagRef]" mode="SubDiagramFlow">
			<xsl:with-param name="SubDiagUniqID" select="CompositeNode/ProcessStep/Node/ModelActivityElement/@UniqID"></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

<!--
	***************************************************************************************************************************************************************************
	Writes the Std Attributes for every activity
	***************************************************************************************************************************************************************************
-->

	<xsl:template name="writeActivityStdAttributes" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
	<xsl:param name="name"></xsl:param>
	<xsl:param name="joinCondition"></xsl:param>
	<xsl:param name="suppressJoinFailure"></xsl:param>
			<xsl:if test="boolean(normalize-space($name))">
				<xsl:attribute name="name"><xsl:value-of select="$name"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($joinCondition))">
			<xsl:attribute name="joinCondition"><xsl:value-of select="$joinCondition"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($suppressJoinFailure))">
			<xsl:attribute name="suppressJoinFailure"><xsl:value-of select="$suppressJoinFailure"></xsl:value-of></xsl:attribute>
			</xsl:if>
	</xsl:template>


<!-- 
	***************************************************************************************************************************************************************************
	Fills in the links
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="Connect" mode="link" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="To" select="@To"/>
		<xsl:variable name="From" select="@From"/>
	      <xsl:variable name="diagramRef" select="ancestor::*[7]/@DiagramRef"/>
<!--	
		<xsl:if test="../../../../../../../ModelScenario/Diagram[@Name=$diagramRef]/DiagramBody/Nodes/InitialNode/PseudoState/Node/ModelActivityElement[@UniqID!=$From]">
-->
<!--
	      <xsl:if test="ancestor::*[7]/ModelScenario/Diagram[@Name= $diagramRef]/DiagramBody/Nodes/InitialNode/PseudoState/Node/ModelActivityElement[@UniqID!=current()/@From]">
-->
			<link>
				<xsl:attribute name="name"><xsl:value-of select="concat(../ModelActivityElement/@UniqID,':',normalize-space($From),'-to-',normalize-space($To))"/></xsl:attribute>
			</link>	
<!--
		</xsl:if>
-->
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Write a source for Transition Links
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="TransitionLink" mode="source" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="To" select="Link/Connect/@To"/>
		<xsl:variable name="From" select="Link/Connect/@From"/>
		<source>
			<xsl:attribute name="linkName"><xsl:value-of select="concat(Link/ModelActivityElement/@UniqID,':',normalize-space($From),'-to-',normalize-space($To))"/></xsl:attribute>
			<xsl:if test="boolean(normalize-space(GuardCondition))">
				<xsl:attribute name="transitionCondition"><xsl:value-of select="GuardCondition"/></xsl:attribute>
			</xsl:if>
		</source>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Write a source for Exception Links
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="ExceptionLink" mode="source" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="To" select="Link/Connect/@To"/>
		<xsl:variable name="From" select="Link/Connect/@From"/>
		<source>
			<xsl:attribute name="linkName"><xsl:value-of select="concat(Link/ModelActivityElement/@UniqID,':',normalize-space($From),'-to-',normalize-space($To))"/></xsl:attribute>
			<xsl:attribute name="transitionCondition">currentException.getType() = '<xsl:value-of select="ExceptionName"></xsl:value-of>'</xsl:attribute>
		</source>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Write a source for Message Links
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="MessageLink" mode="source" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="To" select="Link/Connect/@To"/>
		<xsl:variable name="From" select="Link/Connect/@From"/>
		<source>
			<xsl:attribute name="linkName"><xsl:value-of select="concat(Link/ModelActivityElement/@UniqID,':',normalize-space($From),'-to-',normalize-space($To))"/></xsl:attribute>
		</source>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Used by Source LinkNames
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="Connect" mode="target" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="To" select="@To"/>
		<xsl:variable name="From" select="@From"/>
		<target>
			<xsl:attribute name="linkName"><xsl:value-of select="concat(../ModelActivityElement/@UniqID,':',normalize-space($From),'-to-',normalize-space($To))"/></xsl:attribute>
		</target>
	</xsl:template>
<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Source for each Activity
	***************************************************************************************************************************************************************************
-->

	<xsl:template name="writeSource" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
	<xsl:param name="UniqID"></xsl:param>
	<xsl:param name="linktype"></xsl:param>
			<xsl:choose>
				<xsl:when test="$linktype=1">
						<xsl:apply-templates select="//TransitionLink[Link/Connect/@From=$UniqID]" mode="source"/>
				</xsl:when>
				<xsl:when test="$linktype=2">
						<xsl:apply-templates select="//ExceptionLink[Link/Connect/@From=$UniqID]" mode="source"/>
				</xsl:when>
				<xsl:when test="$linktype=3">
						<xsl:apply-templates select="//TransitionLink[Link/Connect/@From=$UniqID]" mode="source"/>
						<xsl:apply-templates select="//ExceptionLink[Link/Connect/@From=$UniqID]" mode="source"/>
				</xsl:when>
				<xsl:when test="$linktype=4">
						<xsl:apply-templates select="//MessageLink[Link/Connect/@From=$UniqID]" mode="source"/>
				</xsl:when>
				<xsl:when test="$linktype=5">
						<xsl:apply-templates select="//TransitionLink[Link/Connect/@From=$UniqID]" mode="source"/>
						<xsl:apply-templates select="//MessageLink[Link/Connect/@From=$UniqID]" mode="source"/>
				</xsl:when>
				<xsl:when test="$linktype=6">
						<xsl:apply-templates select="//ExceptionLink[Link/Connect/@From=$UniqID]" mode="source"/>
						<xsl:apply-templates select="//MessageLink[Link/Connect/@From=$UniqID]" mode="source"/>
				</xsl:when>
				<xsl:when test="$linktype=7">
						<xsl:apply-templates select="//TransitionLink[Link/Connect/@From=$UniqID]" mode="source"/>
						<xsl:apply-templates select="//ExceptionLink[Link/Connect/@From=$UniqID]" mode="source"/>
						<xsl:apply-templates select="//MessageLink[Link/Connect/@From=$UniqID]" mode="source"/>
				</xsl:when>
			</xsl:choose>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Target for each Activity
	***************************************************************************************************************************************************************************
-->

	<xsl:template name="writeTarget" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
	<xsl:param name="UniqID"></xsl:param>
		<xsl:apply-templates select="//Connect[@To=$UniqID]" mode="target"></xsl:apply-templates>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Returns the container name generated from an Iterator Node
	***************************************************************************************************************************************************************************
-->
	<xsl:template name="getIteratorNodeContainerName" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:choose>
			<!-- Sapphire
			<xsl:when test="IteratorType/@Type = 'BusObj' ">
				<xsl:value-of select="substring-before(BusinessObj,'.')"></xsl:value-of>
			</xsl:when>
			<xsl:when test="IteratorType/@Type = 'Attribute' ">
				<xsl:value-of select="BusinessObj"></xsl:value-of>
			</xsl:when>
			-->
			<xsl:when test="@Type = 'BusObj' ">
				<xsl:value-of select="substring-before(ThruThisObject,'.')"></xsl:value-of>
			</xsl:when>
			<xsl:when test="@Type = 'Attribute' ">
				<xsl:value-of select="ThruThisObject"></xsl:value-of>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>Default</xsl:text>					
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Writes the onMessage for a Pick activity
	***************************************************************************************************************************************************************************
-->
	<xsl:template name="writePickOnMessage" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:for-each select="/CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef/Verbs/Verb">
		<xsl:variable name="ScenarioName" select="ScenarioName"></xsl:variable>
				<xsl:if test="@IsSubscribeEvent='Yes'">
					<onMessage>
						<xsl:attribute name="portType">tns:<xsl:value-of select="../../@Name"></xsl:value-of>PT</xsl:attribute>
						<xsl:attribute name="partner">caller</xsl:attribute>
						<xsl:attribute name="operation"><xsl:value-of select="@Name"></xsl:value-of></xsl:attribute>
						<xsl:attribute name="container"><xsl:value-of select="../../@Name"></xsl:value-of></xsl:attribute>
						<sequence>
						<wswf:script wswf:language="Java">
							triggeringBusObj=new BusObj("<xsl:value-of select="../../@BusObjType"></xsl:value-of>");
						</wswf:script>
							<xsl:call-template name="writePickOnMessageEmptyNode">
								<xsl:with-param name="port" select="../../@Name"></xsl:with-param>
								<xsl:with-param name="operation" select="@Name"></xsl:with-param>
							</xsl:call-template>
						</sequence>
					</onMessage>
				</xsl:if>
		</xsl:for-each>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Writes the new node introduced within the Pick activity. This is to connect to the sub-flows.
	***************************************************************************************************************************************************************************
-->
	<xsl:template name="writePickOnMessageEmptyNode" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:param name="port"></xsl:param>
		<xsl:param name="operation"></xsl:param>
		<xsl:variable name="scenarioName">
			<xsl:value-of select="/CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef[@Name=$port]/Verbs/Verb[@Name=$operation]/ScenarioName"></xsl:value-of>
		</xsl:variable>	
		<xsl:variable name="diagramRef">
			<xsl:value-of select="/CollabTemplate/Scenarios/Scenario[@Name=$scenarioName]/@DiagramRef"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="/CollabTemplate/Scenarios/Scenario[@Name=$scenarioName]/ModelScenario/Diagram[@Name=$diagramRef]/DiagramBody/Nodes/InitialNode"></xsl:apply-templates>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	***************************************************************************************************************************************************************************
-->
	<xsl:template name="writeMainFlowLinks" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<links>
			<xsl:for-each select="/CollabTemplate/Scenarios/Scenario">
				<xsl:variable name="scenarioName" select="@Name"></xsl:variable>	
				<xsl:variable name="diagramRef" select="@DiagramRef">	</xsl:variable>
				<xsl:variable name="initalNodeID" select="ModelScenario/Diagram[@Name=$diagramRef]/DiagramBody/Nodes/InitialNode/PseudoState/Node/ModelActivityElement/@UniqID"></xsl:variable>
				<xsl:apply-templates select="ModelScenario/Diagram[@Name=$diagramRef]/DiagramBody/Links/TransitionLink/Link/Connect[@From=$initalNodeID]" mode="MainFlowLink">
				</xsl:apply-templates>
			</xsl:for-each>
		</links>
	</xsl:template>


<!-- 
	***************************************************************************************************************************************************************************
	Fills in the MainFlow links
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="Connect" mode="MainFlowLink" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:variable name="To" select="@To"/>
		<xsl:variable name="From" select="@From"/>
			<link>
				<xsl:attribute name="name"><xsl:value-of select="concat(../ModelActivityElement/@UniqID,':',normalize-space($From),'-to-',normalize-space($To))"/></xsl:attribute>
			</link>	
	</xsl:template>


<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Assign Node From
	***************************************************************************************************************************************************************************
-->
	<xsl:template name="writeFrom" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:param name="container"></xsl:param>
		<xsl:param name="part"></xsl:param>
		<xsl:param name="select"></xsl:param>
		<xsl:param name="property"></xsl:param>
		<xsl:param name="partner"></xsl:param>
		<xsl:param name="expression"></xsl:param>
		<from>
			<xsl:if test="boolean(normalize-space($container))">
				<xsl:attribute name="container"><xsl:value-of select="$container"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($part))">
				<xsl:attribute name="part"><xsl:value-of select="$part"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($select))">
				<xsl:attribute name="select"><xsl:value-of select="$select"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($property))">
				<xsl:attribute name="property"><xsl:value-of select="$property"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($partner))">
				<xsl:attribute name="partner"><xsl:value-of select="$partner"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($expression))">
				<xsl:attribute name="expression"><xsl:value-of select="$expression"></xsl:value-of></xsl:attribute>
			</xsl:if>
		</from>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the Assign Node To
	***************************************************************************************************************************************************************************
-->
	<xsl:template name="writeTo" xmlns="http://schemas.xmlsoap.org/ws/2002/07/business-process/">
		<xsl:param name="container"></xsl:param>
		<xsl:param name="part"></xsl:param>
		<xsl:param name="select"></xsl:param>
		<xsl:param name="property"></xsl:param>
		<xsl:param name="partner"></xsl:param>
		<xsl:param name="expression"></xsl:param>
		<to>
			<xsl:if test="boolean(normalize-space($container))">
				<xsl:attribute name="container"><xsl:value-of select="$container"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($part))">
				<xsl:attribute name="part"><xsl:value-of select="$part"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($select))">
				<xsl:attribute name="select"><xsl:value-of select="$select"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($property))">
				<xsl:attribute name="property"><xsl:value-of select="$property"></xsl:value-of></xsl:attribute>
			</xsl:if>
			<xsl:if test="boolean(normalize-space($partner))">
				<xsl:attribute name="partner"><xsl:value-of select="$partner"></xsl:value-of></xsl:attribute>
			</xsl:if>
		</to>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	***************************************************************************************************************************************************************************
-->

</xsl:stylesheet>
